//===- Transform/Utils/ArrayDFAUtils.h - ArrayDFAUtils Utils -------------===//
//
// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
// See https://llvm.org/LICENSE.txt for license information.
// SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
//
//===----------------------------------------------------------------------===//
//
// This family of functions required in ArrayDFA transforms
//
//===----------------------------------------------------------------------===//

#ifndef LLVM_TRANSFORMS_UTILS_ARRAYDFAUTILS_H
#define LLVM_TRANSFORMS_UTILS_ARRAYDFAUTILS_H

#include "llvm/Transforms/Utils/LoopUtils.h"
#include "llvm/Analysis/TargetLibraryInfo.h"

namespace llvm {

// Insert preheader in cases where preheader of a loop is inside an adjacent
// loop.
bool InsertPreheadsWhereLoopPredsIsInAdjLoop(LoopInfo *LI, DominatorTree *DT);

} // end namespace llvm

#endif // LLVM_TRANSFORMS_UTILS_ARRAYDFAUTILS_H
