//
//                     The Region Vectorizer
//
// This file is distributed under the University of Illinois Open Source
// License. See LICENSERV.TXT for details.
//
#ifndef RV_TRANSFORM_SROVTRANSFORM_H
#define RV_TRANSFORM_SROVTRANSFORM_H

#include <llvm/IR/Value.h>
#include <llvm/Transforms/Utils/ValueMapper.h>

#include <llvm/Transforms/rv/PlatformInfo.h>
#include <llvm/Transforms/rv/vectorShape.h>

namespace llvm {
  class AllocaInst;
  class DataLayout;
}

namespace rv {

class VectorizationInfo;

class SROVTransform {
  VectorizationInfo & vecInfo;
  const PlatformInfo & platInfo;

public:
  SROVTransform(VectorizationInfo & _vecInfo, const PlatformInfo & _platInfo);

  bool run();
};


} // namespace rv

#endif// RV_TRANSFORM_SROVTRANSFORM_H
