#!/bin/bash 

aocc_fldr=$1
install_prefix=$RPM_INSTALL_PREFIX
set_env_file="$install_prefix/$aocc_fldr/setenv_AOCC.sh"

AOCC_INS_DIR="$install_prefix/$aocc_fldr"
echo "export PATH=$AOCC_INS_DIR/bin:\$PATH" >$set_env_file
echo "export LIBRARY_PATH=$AOCC_INS_DIR/lib:$AOCC_INS_DIR/lib32:/usr/lib/x86_64-linux-gnu:/usr/lib64:/usr/lib32:/usr/lib:\$LIBRARY_PATH" >>$set_env_file
echo "export LD_LIBRARY_PATH=$AOCC_INS_DIR/lib:$AOCC_INS_DIR/lib32:/usr/lib/x86_64-linux-gnu:/usr/lib64:/usr/lib32:/usr/lib:\$LD_LIBRARY_PATH" >>$set_env_file
echo "export C_INCLUDE_PATH=$C_INCLUDE_PATH:$AOCC_INS_DIR/include:\$C_INCLUDE_PATH" >>$set_env_file
echo "export CPLUS_INCLUDE_PATH=$CPLUS_INCLUDE_PATH:$AOCC_INS_DIR/include:\$CPLUS_INCLUDE_PATH" >>$set_env_file
chmod +x $set_env_file

moduleScript="$install_prefix/$aocc_fldr/${aocc_fldr}_module"
echo '#%Module1.0#####################################################################'>$moduleScript
echo " " >>$moduleScript
echo 'proc ModulesHelp { } {' >>$moduleScript
echo '    global version AOCChome' >>$moduleScript
echo '    puts stderr "\tAOCC \n"' >>$moduleScript
echo '    puts stderr "\tloads AOCC compiler setup \n"' >>$moduleScript
echo '}' >>$moduleScript
echo " " >>$moduleScript
echo 'module-whatis "loads AOCC compiler setup "' >>$moduleScript
echo " " >>$moduleScript

echo "set AOCChome ${AOCC_INS_DIR}" >>$moduleScript
echo "prepend-path PATH \$AOCChome/bin" >>$moduleScript
echo "prepend-path LIBRARY_PATH \$AOCChome/lib" >>$moduleScript
echo "prepend-path LIBRARY_PATH \$AOCChome/lib32" >>$moduleScript

echo "prepend-path LD_LIBRARY_PATH \$AOCChome/lib" >>$moduleScript
echo "prepend-path LD_LIBRARY_PATH \$AOCChome/lib32" >>$moduleScript

echo "prepend-path C_INCLUDE_PATH \$AOCChome/include" >>$moduleScript
echo "prepend-path CPLUS_INCLUDE_PATH \$AOCChome/include" >>$moduleScript


loc_lib_path=""

loc_lib_path=""

add_to_loc()
{
fldr=$1
	if [[ -z $loc_lib_path ]];then
		loc_lib_path="$fldr"
	else
		loc_lib_path="$fldr:$loc_lib_path"
	fi
}

if [[ -d '/usr/lib32' ]];then
	add_to_loc '/usr/lib32'
fi

if [[ -d '/usr/lib' ]];then
	add_to_loc '/usr/lib'
fi

if [[ -d '/usr/lib/x86_64-linux-gnu' ]];then
	add_to_loc '/usr/lib/x86_64-linux-gnu'
fi

if [[ -d '/usr/lib64' ]];then
	add_to_loc '/usr/lib64'
fi

if [[ $loc_lib_path != "" ]];then
	echo "export LIBRARY_PATH=$loc_lib_path:\$LIBRARY_PATH" >>$set_env_file
	echo "export LD_LIBRARY_PATH=$loc_lib_path:\$LD_LIBRARY_PATH" >>$set_env_file

	echo "prepend-path LIBRARY_PATH ${loc_lib_path}" >>$moduleScript
	echo "prepend-path LD_LIBRARY_PATH ${loc_lib_path}" >>$moduleScript
fi


